#!/bin/bash
<< COMMENT
    
COMMENT

domain="{{ parent_domain }}"
type="A"
{% set domains_list = [] -%}
{%- for item in domains  -%}
{{ domains_list.append( item.url.split(".")[0] ) }}
{%- endfor -%}
names=("@ {{ domains_list | join(' ')}}")
ttl="600"
port="1"                                    
weight="1"
key="{{ godaddy_api["key"] }}"
secret="{{ godaddy_api["secret"] }}"

headers="Authorization: sso-key $key:$secret"

set -e
#Loop over DNS name records
for name in $names
do
    dnsIp=`curl -s -X GET -H "$headers" \
        "https://api.godaddy.com/v1/domains/$domain/records/$type/$name" | 
        grep -oE "\b([0-9]{1,3}\.){3}[0-9]{1,3}\b"`

    currentIp=`curl -s GET "http://ipinfo.io/json" | jq .ip | grep -oE "\b([0-9]{1,3}\.){3}[0-9]{1,3}\b"`

    if [ "$dnsIp" != "$currentIp" ];
        then
            echo "IP's are not equal, updating record"
            curl -X PUT "https://api.godaddy.com/v1/domains/$domain/records/$type/$name" \
    		-H "accept: application/json" \
    		-H "Content-Type: application/json" \
    		-H "$headers" \
    		-d "[ { \"data\": \"$currentIp\", \"port\": $port, \"priority\": 0, \"protocol\": \"string\", \"service\": \"string\", \"ttl\": $ttl, \"weight\": $weight } ]"  
    fi
done